module PhysicsSandboxCadran

  def add_line(lines, p1 : SF::Vector2f, p2 : SF::Vector2f, color : SF::Color = SF::Color::White)
    line1 = SF::VertexBuffer.new(SF::LineStrip)
    line1.create(2)
    line1.update(
      Slice[
        SF::Vertex.new(position: p1, color: color),
        SF::Vertex.new(position: p2, color: color),
      ], 0)
    lines << line1
  end

  CADRAN_COLOR = SF::Color.new(230, 230, 230, 120)
  def draw_cadran(center : Vector(Float64, 2), radius : Number)
    circle = SF::CircleShape.new(radius: radius, point_count: 100)
    circle.outline_color = CADRAN_COLOR
    circle.outline_thickness = 1
    center_position_offset = {
      center[0] - radius,
      center[1] - radius,
    }
    circle.position = center_position_offset
    circle.fill_color = SF::Color::Transparent
    draw(circle)

    lines = Array(SF::VertexBuffer).new
    add_line(
      lines: lines,
      p1: SF.vector2f(center[0] - 2**(1/2)/2 * radius, center[1] - 2**(1/2)/2 * radius),
      p2: SF.vector2f(center[0] + 2**(1/2)/2 * radius, center[1] + 2**(1/2)/2 * radius),
      color: CADRAN_COLOR,
    )
    add_line(
      lines: lines,
      p1: SF.vector2f(center[0] + 2**(1/2)/2 * radius, center[1] - 2**(1/2)/2 * radius),
      p2: SF.vector2f(center[0] - 2**(1/2)/2 * radius, center[1] + 2**(1/2)/2 * radius),
      color: CADRAN_COLOR,
    )
    add_line(
      lines: lines,
      p1: SF.vector2f(center[0] + radius, center[1]),
      p2: SF.vector2f(center[0] - radius, center[1]),
      color: CADRAN_COLOR,
    )
    add_line(
      lines: lines,
      p1: SF.vector2f(center[0], center[1] - radius),
      p2: SF.vector2f(center[0], center[1] + radius),
      color: CADRAN_COLOR,
    )

    lines.each { |line| draw(line) }
  end

end
