require "crsfml"

module UI
  # `EventHandler` is able to accumulate callbacks that will be triggered every
  # time a event of a given type is received.
  class EventHandler
    # this is shit, find a better way to implement a generic event
    alias Event = SF::Event
    # A callback takes one argument (itself) and returns nothing
    alias EventCallback = EventCallback, Event -> Nil

    # NOTE EventClass.class should return Class so it's not yet what I want
    def initialize
      @events_callbacks = Hash(Event.class, Array(EventCallback)).new
    end

    def event_callbacks(event : Event.class) : Array(EventCallback)
      @events_callbacks[event] ||= Array(EventCallback).new
      @events_callbacks[event]
    end

    def add(event : Event.class, &block : EventCallback, Event -> Nil)
      event_callbacks(event) << block
      block
    end

    def add(event : Event.class, block : EventCallback)
      event_callbacks(event) << block
      block
    end

    def remove(event : Event.class, &block : EventCallback, Event -> Nil)
      event_callbacks(event).delete(block)
    end

    def remove(event : Event.class, block : EventCallback)
      event_callbacks(event).delete(block)
    end

    def handle(event : Event)
      event_callbacks(event.class).each { |callback| callback.call(callback, event) }
    end
  end
end
